# 1. Principles and processes 

**Goals**

Plan and sketch a potential final project

My project will be a **vegetable washing machine** 

Goal is to create a counter top kitchen appliance that can wash and dry greens and 
other vegetables via a pre set cycle.


## Project description 

![VMS SKETCH](../images/imagW1/VMS06.jpeg){: style="height:360px;width:720px"}

![Veg Washing Machine](../images/Finalproject/VWMSKETCHV1.jpg){: style="height:300px;width:300px"}




**There are 4 main parts to the appliance**

1. Water reservoir 

2. Main container (Wash basin)- base is designed to have a gravity fed drain

3. Lid with build in sprinkler 

4. Vegetable holding bowel that sites in the Wash basin and spins to dry 

**There are 2 Motor/pump used**

1. Water pump to move water from reservoir to sprinkler head 

2. Motor to spin Vegetable bowel 

**There are 2 potential sensors**

1. Lid sensor - stop operation if lid is open mid cycle 

2. Water level sensor to alert if reservoir is empty 

**Microcontroller usage**

1. Control sequencing of pumps / motors 

2. Interrupt operation if sensor is triggered 

3. Manage GUI 

**GUI**

1. Based display and buttons

2. Allow user to start cycle 

- Wash only

- Dry only

- Wash/dry

3. Announce alerts (ready/water empty/finished)


## Motor drive example design for high speed dryer 

I like the automated spinning salad dryer that the You Tuber The Practical Engineer designed 

<iframe width="560" height="315" src="https://www.youtube.com/embed/hfGojmXrGfc" title="YouTube video player" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share" allowfullscreen></iframe>

I think that he has a good spinner design and using this approach can allow me to allow users to put in 
any colander they wish.



## Align parts to Fab Academy weekly topics  


 
| Weekly topics      | Parts |
| ----------- | ----------- |
| Computer controlled cutting | Outbox / wash basin holder  |
| Electronics production | Controller, motor ESC, Sensors  |
| 3D Scanning and printing | Motor housing, water connectors, sprinkler head, sproket/chain for motor drive|
| Electronics design | sensors / controller board / Motor ESC |
| Computer controlled machining |   Controller board  |
| Embedded programming | Cycle design / User input |
| Molding and casting | Drain / Spinning plate  |
| Input devices | GUI buttons / Sensors |
| Output devices | Screen |
 


Key component breakdown 

Outer box - Plexiglass  

Wash basin holder - Plexiglass / 3d print 

Water reservoir - molding / buying 

Electronic housing - 3D print 

spinner mechanism - 3D print 

Bowel - Molding / casting 

Lid - 3D Print 

Water pump / sprinkler mechanism - 3D print / electronics 

Sensors - 1) Lid sensor 2) Water level sensor 

Controller board -

Display/Buttons 

Water connections - 3 Print or buy 