# include <Servo.h>

// Define the pin numbers for the sensors and actuators
const int LED_PIN = 7;
const int WASH_BUTTON_PIN = D6;
const int DRY_BUTTON_PIN = D5;
const int FULL_BUTTON_PIN = D4;
const int WATER_SENSOR_PIN = D3;
const int LID_SENSOR_PIN = D1;
const int DRUM_PIN = D0;
const int WATER_PUMP_PIN = D2;
const int DRUM_SLOW = 24;
const int DRUM_FAST = 30;
const int DRUM_STOP = 0;
int potVal;
Servo esc;


void setup() {

    pinMode(LED_PIN, OUTPUT);
    pinMode(WASH_BUTTON_PIN, INPUT_PULLUP);
    pinMode(DRY_BUTTON_PIN, INPUT_PULLUP);
    pinMode(FULL_BUTTON_PIN, INPUT_PULLUP);
    pinMode(WATER_SENSOR_PIN, INPUT_PULLUP);
    pinMode(LID_SENSOR_PIN, INPUT_PULLUP);
    pinMode(DRUM_PIN, OUTPUT);
    pinMode(WATER_PUMP_PIN, OUTPUT);
    Serial.begin(9600);
    esc.attach(DRUM_PIN, 1000, 2000); // the second and third parameters are the minimum and maximum pulse widths    
    esc.write(DRUM_STOP); //arm ESP
    delay(1000);
}

void loop() {
    // Wait for the wash button press
    if (digitalRead(WASH_BUTTON_PIN) == LOW) {
        // Check the water level and lid status
        if (digitalRead(WATER_SENSOR_PIN) == HIGH && digitalRead(LID_SENSOR_PIN) == LOW) {
            // Start the wash cycle
            esc.write(DRUM_SLOW);
            Serial.println("wash");
            digitalWrite(WATER_PUMP_PIN, HIGH);
            delay(800);
            esc.write(DRUM_STOP);
            digitalWrite(WATER_PUMP_PIN, LOW);
              delay(400);
              digitalWrite(WATER_PUMP_PIN, HIGH);
              esc.write(DRUM_FAST);

           delay(800);
            digitalWrite(WATER_PUMP_PIN, LOW);
            esc.write(DRUM_STOP);

        } else {
            Serial.println("Not enough water or lid is open.");
                        digitalWrite(LED_PIN, HIGH);

        }
    }

       // Wait for the dry button press
    if (digitalRead(DRY_BUTTON_PIN) == LOW) {
        // Check the water level and lid status
        if (digitalRead(LID_SENSOR_PIN) == LOW) {
            // Start the dry cycle
            esc.write(DRUM_SLOW);
            Serial.println("Dry");
            delay(1000);
           
              esc.write(DRUM_FAST);

           delay(1000);
            esc.write(DRUM_STOP);

        } else {
            Serial.println("lid is open.");
                        digitalWrite(LED_PIN, HIGH);

        }
    }

  // Wait for the full button press
    if (digitalRead(FULL_BUTTON_PIN) == LOW) {
        // Check the water level and lid status
        if (digitalRead(WATER_SENSOR_PIN) == HIGH && digitalRead(LID_SENSOR_PIN) == LOW) {
            // Start the wash cycle
            esc.write(DRUM_SLOW);
            Serial.println("washfull");
            digitalWrite(WATER_PUMP_PIN, HIGH);
            delay(800);
            esc.write(DRUM_STOP);
            digitalWrite(WATER_PUMP_PIN, LOW);
              delay(400);
              digitalWrite(WATER_PUMP_PIN, HIGH);
              esc.write(DRUM_FAST);

           delay(800);
            digitalWrite(WATER_PUMP_PIN, LOW);
            esc.write(DRUM_STOP);
           delay(800);
            esc.write(DRUM_SLOW);
            Serial.println("Dryfull");
            delay(1000);
           
              esc.write(DRUM_FAST);

           delay(1000);
            esc.write(DRUM_STOP);

        } else {
            Serial.println("Not enough water or lid is open.");
                        digitalWrite(LED_PIN, HIGH);

        }
    }
 
    }

