// include the Servo library
#include <Servo.h>

// create a Servo object to control the ESC
Servo esc;

void setup() {
  // set the baud rate for serial communication
  Serial.begin(9600);

  // attach the ESC to pin 9
  esc.attach(9, 1000, 2000); // the second and third parameters are the minimum and maximum pulse widths
  esc.write(40);
  // wait for the ESC to initialize
  Serial.println("Initializing ESC...");
  delay(3000);
}

void loop() {
  // set the speed to half of the maximum (which is 180)
  int speed = 0;

  // send the speed to the ESC
  esc.write(speed);

  // wait for the motor to ramp up
  delay(2000);

  // print the speed to the serial monitor
  Serial.print("Speed: ");
  Serial.println(speed);

  // pause for a moment before starting again
  delay(5000);
}
